searchNodes=[{"doc":"Integrates Permit with Ecto, providing means to convert permissions to Ecto queries, automatically constructing Ecto.Query scopes to preload records that meet authorization criteria. Dependencies and related libraries Permit.Ecto depends on Permit . It can be used to build custom integrations or in conjunction with Permit.Phoenix , which uses the generated accessible_by/4 functions to automatically preload, authorize and inject records loaded via Ecto into controller assigns (see more in Permit.Phoenix documentation ). Configuration defmodule MyApp.Authorization do use Permit.Ecto , permissions_module : MyApp.Permissions , repo : MyApp.Repo end defmodule MyApp.Permissions do use Permit.Ecto.Permissions , actions_module : Permit.Actions.CrudActions def can ( %{ role : :admin } = user ) do permit ( ) |&gt; all ( MyApp.Blog.Article ) end def can ( %{ id : user_id } = user ) do permit ( ) |&gt; all ( MyApp.Blog.Article , author_id : user_id ) |&gt; read ( MyApp.Blog.Article ) end def can ( user ) , do : permit ( ) end iex&gt; MyApp.Repo . all ( MyApp.Blog.Article ) [ % MyApp.Blog.Article { id : 1 , author_id : 1 } , % MyApp.Blog.Article { id : 2 , author_id : 1 } , % MyApp.Blog.Article { id : 3 , author_id : 2 } ] # The `accessible_by!/3` function also has a `accessible_by/3` variant which returns `{:ok, ...}` tuples. iex&gt; MyApp.Permissions . accessible_by! ( % MyApp.Users.User { id : 1 } , :update , MyApp.Blog.Article ) [ % MyApp.Blog.Article { id : 1 , ... } , % MyApp.Blog.Article { id : 2 , ... } ] iex&gt; MyApp.Permissions . accessible_by! ( % MyApp.Users.User { id : 1 } , :read , MyApp.Blog.Article ) [ % MyApp.Blog.Article { id : 1 , ... } , % MyApp.Blog.Article { id : 2 , ... } , % MyApp.Blog.Article { id : 3 , ... } ] iex&gt; MyApp.Permissions . accessible_by! ( % MyApp.Users.User { id : 3 , role : :admin } , :update , MyApp.Blog.Article ) [ % MyApp.Blog.Article { id : 1 , ... } , % MyApp.Blog.Article { id : 2 , ... } , % MyApp.Blog.Article { id : 3 , ... } ]","ref":"Permit.Ecto.html","title":"Permit.Ecto","type":"module"},{"doc":"Defines the application's permission set. Replaces Permit.Permissions when Permit.Ecto is used, but its syntax is identical. Example defmodule MyApp.Permissions do use Permit.Permissions , actions_module : Permit.Actions.CrudActions @impl true def can ( % MyApp.User { role : :admin } ) do permit ( ) |&gt; all ( Article ) end def can ( % MyApp.User { id : user_id } ) do permit ( ) |&gt; read ( Article ) |&gt; all ( Article , author_id : user_id ) end def can ( _ ) , do : permit ( ) end Associations Conditions can be also defined for values of columns of associated records in belongs_to , has_one and has_many associations. Generated queries will automatically include appropriate joins for associated tables recursively. Example def can ( user ) do permit ( ) |&gt; read ( Article , reviews : [ approved : true ] ) # has_many association - any review is approved |&gt; read ( Article , settings : [ visible : true ] ) # has_one association - if settings.visible is true |&gt; read ( Article , author : [ region : [ code : user . region_code ] ] ) # belongs_to association, recursive end Condition conversion Conditions defined using standard operators such as equality, inequality, greater-than, less-than, LIKE and ILIKE are converted automatically (see Permit.Operators ). Other conditions, such as those given as functions, Refer to Permit.Permissions documentation for more examples of usage.","ref":"Permit.Ecto.Permissions.html","title":"Permit.Ecto.Permissions","type":"module"},{"doc":"","ref":"Permit.Ecto.Permissions.html#construct_query/6","title":"Permit.Ecto.Permissions.construct_query/6","type":"function"},{"doc":"Joins a DNF of conditions represented by a Permit.Permissions.DisjunctiveNormalForm into an Ecto dynamic query. Part of the private API, subject to changes and not to be used on the application level.","ref":"Permit.Ecto.Permissions.DynamicQueryJoiner.html","title":"Permit.Ecto.Permissions.DynamicQueryJoiner","type":"module"},{"doc":"","ref":"Permit.Ecto.Permissions.DynamicQueryJoiner.html#add_joins/2","title":"Permit.Ecto.Permissions.DynamicQueryJoiner.add_joins/2","type":"function"},{"doc":"","ref":"Permit.Ecto.Permissions.DynamicQueryJoiner.html#to_dynamic_query/4","title":"Permit.Ecto.Permissions.DynamicQueryJoiner.to_dynamic_query/4","type":"function"},{"doc":"Represents the product of parsing a condition by a function implementing the Permit.Permissions.can/1 callback. Replaces Permit.Permissions.ParsedCondition in applications using Permit.Ecto . Refer to Permit.Permissions.ParsedCondition documentation for more details. In add_conditionition to the original implementation, its metadata also includes dynamic query constructors, derived from Permit.Operators.DynamicQuery . A condition parsed by Permit's rule syntax parser contains: condition semantics, that is: a function that allows for checking whether the condition is satisfied an indication of whether it is negated (i.e. a condition defined as {:not, ...} ) metadata ( :private ), which can be used by alternative parsers (e.g. Permit.Ecto.Permissions puts dynamic query constructors there) Part of the private API, subject to changes and not to be used on the application level.","ref":"Permit.Ecto.Permissions.ParsedCondition.html","title":"Permit.Ecto.Permissions.ParsedCondition","type":"module"},{"doc":"","ref":"Permit.Ecto.Permissions.ParsedCondition.html#to_dynamic_query/4","title":"Permit.Ecto.Permissions.ParsedCondition.to_dynamic_query/4","type":"function"},{"doc":"","ref":"Permit.Ecto.Permissions.ParsedCondition.html#t:dynamic_query/0","title":"Permit.Ecto.Permissions.ParsedCondition.dynamic_query/0","type":"type"},{"doc":"Implemented to define a dynamic query builder function for an operator, that is a module that implements Permit.Operators.GenOperator . For example, when an operator is defined in the Permit.Operators.Eq module, its dynamic query builder function should be defined in Permit.Operators.Eq.DynamicQuery . Part of the private API, subject to changes and not to be used on the application level.","ref":"Permit.Operators.DynamicQuery.html","title":"Permit.Operators.DynamicQuery","type":"behaviour"},{"doc":"","ref":"Permit.Operators.DynamicQuery.html#c:dynamic_query_fn/2","title":"Permit.Operators.DynamicQuery.dynamic_query_fn/2","type":"callback"},{"doc":"Implementation of Permit.ResolverBase behaviour, resolving and checks authorization of records or lists of records based on automatic Ecto query construction, taking parameters as input and :base_query and :finalize_query functions as means to transform the query based on e.g. current controller context. For a resolver implementation not using Ecto for fetching resources, see Permit.Resolver from the permit library. The usage of Permit.Ecto.Resolver as opposed to Permit.Resolver in permit_ecto library occurs because in the m:Permit.Ecto.__using__/1 macro the resolver_module/0 function is overridden to point to Permit.Ecto.Resolver . This module is to be considered a private API of the authorization framework. It should not be directly used by application code, but rather by wrappers providing integration with e.g. Plug or LiveView.","ref":"Permit.Ecto.Resolver.html","title":"Permit.Ecto.Resolver","type":"module"},{"doc":"","ref":"Permit.Ecto.Resolver.html#authorize_and_preload_all!/5","title":"Permit.Ecto.Resolver.authorize_and_preload_all!/5","type":"function"},{"doc":"","ref":"Permit.Ecto.Resolver.html#authorize_and_preload_one!/5","title":"Permit.Ecto.Resolver.authorize_and_preload_one!/5","type":"function"},{"doc":"","ref":"Permit.Ecto.Resolver.html#authorized?/4","title":"Permit.Ecto.Resolver.authorized?/4","type":"function"},{"doc":"Defines Ecto-specific types for usage with Permit.","ref":"Permit.Ecto.Types.html","title":"Permit.Ecto.Types","type":"module"},{"doc":"Allows defining a base Ecto query based on current resolution context, e.g. query parameters, request URL or anything else (depending on execution context).","ref":"Permit.Ecto.Types.html#t:base_query/0","title":"Permit.Ecto.Types.base_query/0","type":"type"},{"doc":"Allows manipulating the query after it has been constructed by Permit's query builder, but before it is executed by Permit.Ecto.Resolver .","ref":"Permit.Ecto.Types.html#t:finalize_query/0","title":"Permit.Ecto.Types.finalize_query/0","type":"type"},{"doc":"Provides new types for usage with Ecto queries, as well as replacements for types initially defined in Permit.Types.ConditionTypes .","ref":"Permit.Ecto.Types.ConditionTypes.html","title":"Permit.Ecto.Types.ConditionTypes","type":"module"},{"doc":"","ref":"Permit.Ecto.Types.ConditionTypes.html#t:condition/0","title":"Permit.Ecto.Types.ConditionTypes.condition/0","type":"type"},{"doc":"","ref":"Permit.Ecto.Types.ConditionTypes.html#t:condition_or_conditions/0","title":"Permit.Ecto.Types.ConditionTypes.condition_or_conditions/0","type":"type"},{"doc":"","ref":"Permit.Ecto.Types.ConditionTypes.html#t:fn1_condition_with_query/0","title":"Permit.Ecto.Types.ConditionTypes.fn1_condition_with_query/0","type":"type"},{"doc":"","ref":"Permit.Ecto.Types.ConditionTypes.html#t:fn2_condition_with_query/0","title":"Permit.Ecto.Types.ConditionTypes.fn2_condition_with_query/0","type":"type"},{"doc":"","ref":"Permit.Ecto.UnconvertibleConditionError.html","title":"Permit.Ecto.UnconvertibleConditionError","type":"exception"},{"doc":"Raised when the permissions module (implementing Permit.Permissions ) does not contain sufficient information to compute authorization for a given action.","ref":"Permit.Ecto.UndefinedConditionError.html","title":"Permit.Ecto.UndefinedConditionError","type":"exception"}]